package sun.awt;

import java.awt.Dimension;
import java.awt.image.PixelGrabber;
import java.awt.MediaTracker;
import java.awt.Canvas;
import java.awt.Toolkit;
import java.awt.Point;
import java.awt.Image;
import java.awt.Cursor;

public abstract class CustomCursor extends Cursor
{
    protected Image image;
    
    public CustomCursor(Image scaledInstance, Point point, String name) throws IndexOutOfBoundsException {
        super(name);
        this.image = scaledInstance;
        Toolkit defaultToolkit = Toolkit.getDefaultToolkit();
        Canvas comp = new Canvas();
        MediaTracker mediaTracker = new MediaTracker(comp);
        mediaTracker.addImage(scaledInstance, 0);
        try {
            mediaTracker.waitForAll();
        }
        catch (InterruptedException ex) {}
        int n = scaledInstance.getWidth(comp);
        int n2 = scaledInstance.getHeight(comp);
        if (mediaTracker.isErrorAny() || n < 0 || n2 < 0) {
            int n3 = 0;
            point.y = n3;
            point.x = n3;
        }
        Dimension bestCursorSize = defaultToolkit.getBestCursorSize(n, n2);
        if ((bestCursorSize.width != n || bestCursorSize.height != n2) && bestCursorSize.width != 0 && bestCursorSize.height != 0) {
            scaledInstance = scaledInstance.getScaledInstance(bestCursorSize.width, bestCursorSize.height, 1);
            n = bestCursorSize.width;
            n2 = bestCursorSize.height;
        }
        if (point.x >= n || point.y >= n2 || point.x < 0 || point.y < 0) {
            throw new IndexOutOfBoundsException("invalid hotSpot");
        }
        int[] pix = new int[n * n2];
        PixelGrabber o = new PixelGrabber(scaledInstance.getSource(), 0, 0, n, n2, pix, 0, n);
        try {
            o.grabPixels();
        }
        catch (InterruptedException ex2) {}
        this.createNativeCursor(this.image, pix, n, n2, point.x, point.y);
        return;
    }
    
    protected abstract void createNativeCursor(Image p0, int[] p1, int p2, int p3, int p4, int p5);
}
